Summary: Multi-platform GUI toolkit
Name: spComponent
Version: 0.6.21
Release: 3
License: distributable
Distribution: (none)
Vendor: (none)
Group: Development/Libraries
Source: %{name}-%{version}-%{release}.tgz
URL: http://www-ie.meijo-u.ac.jp/labs/rj001/spLibs/index.html
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: gtk2-devel, spBase >= 0.8.21, libpng-devel, libjpeg-turbo-devel
%if 0%{?rhel} >= 7
BuildRequires: findutils, gtk2-devel, gtk3-devel, openmotif-devel, libXpm-devel, libpng-devel, libjpeg-turbo-devel, spBase >= 0.8.21
%else
BuildRequires: findutils, gtk2-devel, openmotif-devel, libXpm-devel, libpng-devel, libjpeg-turbo-devel, spBase >= 0.8.21
%endif
%define __spec_install_post /usr/lib/rpm/brp-compress || :

%description 
spComponent is a GUI toolkit working on multiple platforms written in
C. By using this library, you can create excellent GUI easily. Currently,
spComponent supports Windows, MacOS X, UNIX (Motif and gtk+), iOS, and Android.

%package motif
Summary: Multi-platform GUI toolkit (Motif version)
Group: Development/Libraries
Requires: openmotif-devel, libXpm-devel, libpng-devel, libjpeg-turbo-devel, spBase >= 0.8.21, spComponent = %{version}-%{release}, xorg-x11-fonts-ISO8859-1-75dpi, xorg-x11-fonts-ISO8859-1-100dpi, xorg-x11-fonts-misc
%description motif
spComponent is a GUI toolkit working on multiple platforms written in
C. By using this library, you can create excellent GUI easily. Currently,
spComponent supports Windows, MacOS X, UNIX (Motif and gtk+), iOS, and Android.
This package includes spComponent of Motif version.

%package android
Summary: spComponent library of for Android development
Group: Development/Libraries
License: nonfree
BuildArch: noarch
Requires: spBase-android >= 0.8.21
%description android
This package includes spComponent library for Android development.

%package plugins
Summary: Plug-ins for spComponent
Group: System Environment/Libraries
%description plugins
This is a collection of plug-ins for spComponent.

%changelog
* Mon Jan 07 2019  Hideki Banno
- Version 0.6.21-3

* Tue Nov 20 2018  Hideki Banno
- Version 0.6.21-2

* Sat Nov 12 2016  Hideki Banno
- Version 0.6.20-4

* Mon May 16 2016  Hideki Banno
- Version 0.6.20

* Fri Sep 19 2014  Hideki Banno
- Version 0.6.18

* Mon Sep  3 2012  Hideki Banno
- Version 0.6.14

* Tue Oct  2 2007  Hideki Banno
- Version 0.6.9-1

* Mon Aug 21 2006  Hideki Banno
- Version 0.6.7-1

* Sun Jul 11 2004  Hideki Banno
- Version 0.6.6-1b

* Mon Aug 25 2003  Hideki Banno
- Version 0.6.5-4

* Fri Mar 22 2002  Hideki Banno
- Version 0.6.5

* Tue Mar 13 2001  Hideki Banno
- Version 0.6.4

* Thu Jan  4 2001  Hideki Banno
- Version 0.6.3

* Sun Oct  8 2000  Hideki Banno
- Version 0.6.2

* Sun Jun 18 2000  Hideki Banno
- Version 0.6.1

* Fri Aug 27 1999  Hideki Banno
- Version 0.5.4

* Thu Apr 15 1999  Hideki Banno
- version 0.4.0

* Thu Feb 18 1999  Hideki Banno
- 1st release

%prep
%setup -q
%{__rm} -rf %{buildroot}
%{__mkdir_p} %{buildroot}%{_prefix}

%build
%define debug_package %{nil}
cd spComponent
cd example
%{__make} TOP=%{_prefix} SPLIBDIRNAME=%{_lib} cleanbin
cp Makefile Makefile.org
cp Makefile.main Makefile.main.org
%{__sed} -e "s|\.\./\.\.|%{_prefix}|" -e "s|= lib|= %{_lib}|" Makefile.org > Makefile
%{__sed} -e "s|\.\./\.\.|%{_prefix}|" -e "s|= lib|= %{_lib}|" Makefile.main.org > Makefile.main
%{__rm} -f Makefile.org Makefile.main.org
%{__rm} -f *.r
%{__rm} -f *.bmp
%{__rm} -f *.aps
%{__rm} -f *.rc
%{__rm} -f *.ico
%{__rm} -f *.suo
%{__rm} -f *.sln
%{__rm} -f *.make
%{__rm} -rf vc
%{__rm} -rf Debug*
%{__rm} -rf debug*
%{__rm} -rf Release*
%{__rm} -rf release*
%{__rm} -rf x64
%{__rm} -rf xcode
%{__rm} -rf cocoa
%{__rm} -rf ios

mkfiles=`find android -name Android.mk`
for mkfile in ${mkfiles} ; do
    %{__sed} -i \
	-e 's|SP_INCLUDE_TOP := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./include|SP_INCLUDE_TOP := /usr/share/sp/include|g' \
	-e 's|SP_BASE_TOP := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./spBase|SP_BASE_TOP := /usr/share/sp/spBase|g' \
	-e 's|SP_BASE_LIB_LOCAL := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./spBase/android/obj/local|SP_BASE_LIB_LOCAL := $(SP_BASE_TOP)/android/obj/local|g' \
	-e 's|SP_COMPONENT_TOP := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./spComponent|SP_COMPONENT_TOP := /usr/share/sp/spComponent|g' \
	-e 's|SP_COMPONENT_ANDROID_TOP := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./spComponent|SP_COMPONENT_ANDROID_TOP := /usr/share/sp/spComponent|g' \
	"${mkfile}"
done

cd ..

cd ..

%install
%{__mkdir_p} %{buildroot}%{_datadir}/sp/spComponent/android/obj
%{__mkdir_p} %{buildroot}%{_datadir}/sp/spComponent/android/bin
cd spComponent
%{__make} USE_GTK2=y TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install
%{__make} USE_GTK2=y TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install.hdr
if [ -d /usr/include/gtk-3.0 ]; then
    %{__make} USE_GTK3=y TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install
    %{__make} USE_GTK3=y TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install.hdr
fi
%{__make} USE_GTK=n USE_MOTIF=y TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install
%{__make} USE_GTK=n USE_MOTIF=y TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install.hdr
cp -r android/obj/local %{buildroot}%{_datadir}/sp/spComponent/android/obj/
cp -r android/bin/* %{buildroot}%{_datadir}/sp/spComponent/android/bin/
cd ..
%{__strip} --strip-debug %{buildroot}%{_libdir}/lib*.a
if [ -f %{buildroot}%{_libdir}/libspc-gtk.linux-glibc.a ]; then
    %{__ln_s} libspc-gtk.linux-glibc.a %{buildroot}%{_libdir}/libspc-gtk.linux.a
fi
if [ -f %{buildroot}%{_libdir}/libspc-gtk2.linux-glibc.a ]; then
    %{__ln_s} libspc-gtk2.linux-glibc.a %{buildroot}%{_libdir}/libspc-gtk2.linux.a
fi
if [ -f %{buildroot}%{_libdir}/libspc-gtk3.linux-glibc.a ]; then
    %{__ln_s} libspc-gtk3.linux-glibc.a %{buildroot}%{_libdir}/libspc-gtk3.linux.a
fi
if [ -f %{buildroot}%{_libdir}/libspc.linux-glibc.a ]; then
    %{__ln_s} libspc.linux-glibc.a %{buildroot}%{_libdir}/libspc.linux.a
fi

%{__mkdir_p} lib/sp/plugins
%{__mkdir_p} %{buildroot}%{_libdir}/sp/plugins
%{__ln_s} %{_libdir}/libspb.*.a lib/
%{__ln_s} %{_libdir}/sp/{*.cf,*.rules,*.def,Make*} lib/sp/
%{__ln_s} %{_includedir} spBase
cd spComponent/DIBitmapPlugin/png
%{__make} clean
%{__make} 
%{__make} PLUGINDEST=%{buildroot}%{_libdir}/sp/plugins install
cd ../jpeg
%{__make} clean
%{__make} 
%{__make} PLUGINDEST=%{buildroot}%{_libdir}/sp/plugins install
cd ../../..
%{__strip} --strip-debug %{buildroot}%{_libdir}/sp/plugins/*.so

%clean
%{__rm} -rf %{buildroot}

%pre
%post
%preun
%postun

%files 
%defattr(-,root,root)
%doc spComponent/README* spComponent/CHANGES* spComponent/LICENSE*
%doc spComponent/BUGS* spComponent/TODO* spComponent/FILES* 
%doc spComponent/example
%{_libdir}/libspc-gtk*.a
%{_includedir}/sp/spComponentLib.h
%{_includedir}/sp/spComponentMain.h
%{_includedir}/sp/spComponentDefs.h
%{_includedir}/sp/spKeySym.h
%{_includedir}/sp/spObject.h
%{_includedir}/sp/spObjectP.h
%{_includedir}/sp/spLocaleDefs.h
%{_includedir}/sp/spLocale.h
%{_includedir}/sp/spLocaleP.h
%{_includedir}/sp/spStringDefs.h
%{_includedir}/sp/spStringDefs_C.h
%{_includedir}/sp/spStringDefs_EUCJP.h
%{_includedir}/sp/spStringDefs_UTF8JP.h
%{_includedir}/sp/spStringDefs_SJIS.h
%{_includedir}/sp/spTopLevel.h
%{_includedir}/sp/spTopLevelP.h
%{_includedir}/sp/spComponent.h
%{_includedir}/sp/spComponentP.h
%{_includedir}/sp/spPrimitive.h
%{_includedir}/sp/spPrimitiveP.h
%{_includedir}/sp/spFrame.h
%{_includedir}/sp/spFrameP.h
%{_includedir}/sp/spDialog.h
%{_includedir}/sp/spDialogP.h
%{_includedir}/sp/spText.h
%{_includedir}/sp/spTextP.h
%{_includedir}/sp/spLabel.h
%{_includedir}/sp/spLabelP.h
%{_includedir}/sp/spButton.h
%{_includedir}/sp/spButtonP.h
%{_includedir}/sp/spList.h
%{_includedir}/sp/spListP.h
%{_includedir}/sp/spComboBox.h
%{_includedir}/sp/spComboBoxP.h
%{_includedir}/sp/spContainer.h
%{_includedir}/sp/spContainerP.h
%{_includedir}/sp/spCanvas.h
%{_includedir}/sp/spCanvasP.h
%{_includedir}/sp/spSlider.h
%{_includedir}/sp/spSliderP.h
%{_includedir}/sp/spMenu.h
%{_includedir}/sp/spMenuP.h
%{_includedir}/sp/spMenuItem.h
%{_includedir}/sp/spMenuItemP.h
%{_includedir}/sp/spDraw.h
%{_includedir}/sp/spDrawP.h
%{_includedir}/sp/spImage.h
%{_includedir}/sp/spImageP.h
%{_includedir}/sp/spGraphics.h
%{_includedir}/sp/spGraphicsP.h
%{_includedir}/sp/spTabBox.h
%{_includedir}/sp/spTabBoxP.h
%{_includedir}/sp/spToolBar.h
%{_includedir}/sp/spToolBarP.h
%{_includedir}/sp/spToolItem.h
%{_includedir}/sp/spToolItemP.h
%{_includedir}/sp/spStatusBar.h
%{_includedir}/sp/spStatusBarP.h
%{_includedir}/sp/spProgressBar.h
%{_includedir}/sp/spProgressBarP.h
%{_includedir}/sp/spDIBitmap.h
%{_includedir}/sp/spDIBitmapP.h
%{_includedir}/sp/spDialogBox.h
%{_includedir}/sp/spDialogBoxP.h
%{_includedir}/sp/spParamField.h
%{_includedir}/sp/spParamFieldP.h
%{_includedir}/sp/spDial.h
%{_includedir}/sp/spDialP.h
%{_includedir}/sp/spDrawingPlugin.h
%{_includedir}/sp/spDrawingPluginP.h
%{_includedir}/sp/spPluginCanvas.h
%{_includedir}/sp/spPluginCanvasP.h
%{_includedir}/sp/spTopLevel_Gtk.h
%{_includedir}/sp/spComponent_Gtk.h
%{_includedir}/sp/spPrimitive_Gtk.h
%{_includedir}/sp/spFrame_Gtk.h
%{_includedir}/sp/spDialog_Gtk.h
%{_includedir}/sp/spText_Gtk.h
%{_includedir}/sp/spLabel_Gtk.h
%{_includedir}/sp/spButton_Gtk.h
%{_includedir}/sp/spList_Gtk.h
%{_includedir}/sp/spComboBox_Gtk.h
%{_includedir}/sp/spContainer_Gtk.h
%{_includedir}/sp/spCanvas_Gtk.h
%{_includedir}/sp/spSlider_Gtk.h
%{_includedir}/sp/spMenu_Gtk.h
%{_includedir}/sp/spMenuItem_Gtk.h
%{_includedir}/sp/spDraw_Gtk.h
%{_includedir}/sp/spGraphics_Gtk.h
%{_includedir}/sp/spTabBox_Gtk.h
%{_includedir}/sp/spToolBar_Gtk.h
%{_includedir}/sp/spToolItem_Gtk.h
%{_includedir}/sp/spStatusBar_Gtk.h
%{_includedir}/sp/spDIBitmap_Gtk.h

%files motif
%defattr(-,root,root)
%{_libdir}/libspc.*.a
%{_includedir}/sp/spTopLevel_Xm.h
%{_includedir}/sp/spComponent_Xm.h
%{_includedir}/sp/spPrimitive_Xm.h
%{_includedir}/sp/spFrame_Xm.h
%{_includedir}/sp/spDialog_Xm.h
%{_includedir}/sp/spText_Xm.h
%{_includedir}/sp/spLabel_Xm.h
%{_includedir}/sp/spButton_Xm.h
%{_includedir}/sp/spList_Xm.h
%{_includedir}/sp/spComboBox_Xm.h
%{_includedir}/sp/spContainer_Xm.h
%{_includedir}/sp/spCanvas_Xm.h
%{_includedir}/sp/spSlider_Xm.h
%{_includedir}/sp/spMenu_Xm.h
%{_includedir}/sp/spMenuItem_Xm.h
%{_includedir}/sp/spDraw_Xm.h
%{_includedir}/sp/spGraphics_Xm.h
%{_includedir}/sp/spTabBox_Xm.h
%{_includedir}/sp/spToolBar_Xm.h
%{_includedir}/sp/spToolItem_Xm.h
%{_includedir}/sp/spStatusBar_Xm.h
%{_includedir}/sp/spDIBitmap_Xm.h

%files plugins
%defattr(-,root,root)
%doc spComponent/DIBitmapPlugin/README*
%{_libdir}/sp/plugins/*

%files android
%defattr(-,root,root)
%{_datadir}/sp/spComponent/
